/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.ModulAplikasiDto;
import com.portofolio.service.ModulAplikasiService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/modulAplikasi")
public class ModulAplikasiController extends LocaleController {
	@Lazy
	@Autowired
	private ModulAplikasiService modulAplikasiService;

	
	@ApiOperation("Api Untuk Menyimpan ModulAplikasi")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody ModulAplikasiDto entity, HttpServletRequest request) {
		Map<String, Object> result = modulAplikasiService.save(entity);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Update ModulAplikasi")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdModulAplikasi", required = true) String kdModulAplikasi,
			@RequestParam(value = "version", required = true) Integer version, 
			@Valid @RequestBody ModulAplikasiDto entity, HttpServletRequest request) {
		Map<String, Object> result = modulAplikasiService.update(entity, kdModulAplikasi,version);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menghapus ModulAplikasi BerdasarkanKdModulAplikasi")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> deleteById(
			@RequestParam(value = "kdModulAplikasi", required = true) String kdModulAplikasi,
			@RequestParam(value = "version", required = true) Integer version) {
		Map<String, Object> result = modulAplikasiService.deleteByKdModulAplikasi(kdModulAplikasi,version);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan Semua ModulAplikasi")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> grid(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = stringAsIntegerMaxValue) Integer rows,
			@RequestParam(value = "dir", defaultValue = "namaModulAplikasi") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaModulAplikasi", required = false) String namaModulAplikasi,
			@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
		Map<String, Object> result = modulAplikasiService.grid(page, rows, sort, dir, namaModulAplikasi,statusEnabled);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan ModulAplikasi Berdasarkan kode")
	@GetMapping("/findByKdModulAplikasi")
	public ResponseEntity<Map<String, Object>> findByKdModulAplikasi(
			@RequestParam(value = "kdModulAplikasi", required = true) String kdModulAplikasi,
			HttpServletRequest request) {
		Map<String, Object> result = modulAplikasiService.findByKdModulAplikasi(kdModulAplikasi);
		return RestUtil.getJsonResponse(result);
	}

	
}
